/**
 * Source: http://experience-aem.blogspot.com/2015/06/aem-61-classic-ui-composite-multifield-storing-values-as-nodes.html <br>
 * Adapted to create same structure as Granite UI multifield.
 */
CQ.Ext.ns("SiteimproveAEM");

SiteimproveAEM.MultiFieldPanel = CQ.Ext.extend(CQ.Ext.Panel, {
    constructor: function(config){
        config = config || {};
        SiteimproveAEM.MultiFieldPanel.superclass.constructor.call(this, config);
    },

    initComponent: function () {
        SiteimproveAEM.MultiFieldPanel.superclass.initComponent.call(this);

        function addName(items, prefix, counter){
            items.each(function(i){
                if(!i.hasOwnProperty("dName")){
                    return;
                }

                i.name = prefix + "/item" + (counter) + "/" + i.dName;

                //workaround for xtype select
                if(i.hiddenField){
                    i.hiddenField.name = prefix + "/item" + (counter) + "/" + i.dName;
                }

                if(i.el && i.el.dom){ //form serialization workaround
                    i.el.dom.name = prefix + "/item" + (counter) + "/" + i.dName;
                }
            },this);
        }

        var multi = this.findParentByType("multifield"),
            multiPanels = multi.findByType("siteimprove-multi-field-panel");

        addName(this.items, this.name, multiPanels.length);

        multi.on("removeditem", function(){
            // FIXME: this bugs a lot with moving/deleting items
            multiPanels = multi.findByType("siteimprove-multi-field-panel");

            for(var x = 0; x < multiPanels.length; x++){
                addName(multiPanels[x].items, multiPanels[x].name, x);
            }
        });

        // ensure proper rendering of multifield
        var tabPanel = multi.findParentByType("tabpanel");
        if(tabPanel){
            tabPanel.on("tabchange", function(panel){
                panel.doLayout();
            });
        }
    },

    afterRender : function(){
        SiteimproveAEM.MultiFieldPanel.superclass.afterRender.call(this);

        this.items.each(function(){
            if(!this.contentBasedOptionsURL
               || this.contentBasedOptionsURL.indexOf(CQ.form.Selection.PATH_PLACEHOLDER) < 0){
                return;
            }

            this.processPath(this.findParentByType('dialog').path);
        })
    },

    getValue: function () {
        var pData = {};

        this.items.each(function(i){
            if(!i.hasOwnProperty("dName")){
                return;
            }

            pData[i.dName] = i.getValue();
        });

        return pData;
    },

    setValue: function (value) {
        var counter = 0, item,
            multi = this.findParentByType("multifield"),
            multiPanels = multi.findByType("siteimprove-multi-field-panel");

        // called for each entry of the multifield
        if(multiPanels.length == 1){
            var key = "item" + counter;
            item = value[key];
        }else{
            item = value;
        }

        // basically the select and the threshold field
        // setting the first field
        this.items.each(function(i){
            if(!i.hasOwnProperty("dName")){
                return;
            }

            i.setValue(item[i.dName]);
        });


        if(multiPanels.length == 1){
            while(true){
                item = value["item" + (++counter)];

                if(!item){
                    break;
                }

                multi.addItem(item);
            }
        }
    },

    validate: function(){
        return true;
    },

    getName: function(){
        return this.name;
    }
});

CQ.Ext.reg("siteimprove-multi-field-panel", SiteimproveAEM.MultiFieldPanel);
